# Embedded file name: D:\InunxLABS\PythonS60\SimpleServer\version\full\ext\1.02.72_224636\ServerGApp.py
import re
import zlib
import errno
import socket
import base64
import urllib
import urllib2
import urlparse
import ServerInfo
import ServerMisc
import ServerConfig
import SocketServer
import BaseHTTPServer
#try:
import ServerMainUI

sets = ServerConfig.Sets()

def ServerUpdate():
    global sets
    sets = ServerConfig.Sets()


class ProxyHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    PostDataLimit = 1048576

    def __getattr__(self, item):
        if item.startswith('do_'):
            return self.do_COMMAND

    def do_CONNECT(self):
        self.send_error(501, 'Method not allowed.')
        self.connection.close()

    def do_COMMAND(self):
        method = self.command
        if method == 'GET' or method == 'HEAD':
            post_data_len = 0
        elif method == 'POST':
            post_data_len = 0
            for header in self.headers:
                if header.lower() == 'content-length':
                    post_data_len = int(self.headers[header])
                    break

            if post_data_len > self.PostDataLimit:
                self.send_error(413, "Sorry, Google's limit, file size up to 1MB.")
                self.connection.close()
                return
        else:
            self.send_error(501, 'Method not allowed.')
            self.connection.close()
            return
        post_data = ''
        if post_data_len > 0:
            post_data = self.rfile.read(post_data_len)
            if len(post_data) != post_data_len:
                self.send_error(400, 'Post data length error.')
                self.connection.close()
                return
        scm, netloc, path, params, query, _ = urlparse.urlparse(self.path)
        if scm.lower() != 'http' or not netloc:
            self.send_error(501, 'Unsupported scheme.')
            self.connection.close()
            return
        path = urlparse.urlunparse((scm,
         netloc,
         path,
         params,
         query,
         ''))
        hdr_list = [sets.CUSHDR0,
         sets.CUSHDR1,
         sets.CUSHDR2,
         sets.CUSHDR3]
        val_list = [sets.VALHDR0,
         sets.VALHDR1,
         sets.VALHDR2,
         sets.VALHDR3]
        ua_hdr = 'user-agent'
        for i in range(len(hdr_list)):
            if hdr_list[i].lower() == ua_hdr:
                if ua_hdr in self.headers:
                    del self.headers[ua_hdr]
                self.headers[ua_hdr] = val_list[i]

        dhs = []
        for header in self.headers:
            hl = header.lower()
            if hl == 'if-range':
                dhs.append(header)
            elif hl == 'range':
                dhs.append(header)

        for dh in dhs:
            del self.headers[dh]

        auth_data = '%s by %s' % (ServerInfo.Info('name').get_info(), ServerInfo.Info('by').get_info())
        params = urllib.urlencode({'method': method,
         'encoded_path': base64.b64encode(path),
         'headers': base64.b64encode(str(self.headers)),
         'postdata': base64.b64encode(post_data),
         'authdata': base64.b64encode(auth_data),
         'version': sets.GAPPVER})
        request = urllib2.Request('http://%s' % sets.GAPPSVR)
        request.add_header('Accept-Encoding', 'identity, *;q=0')
        request.add_header('Connection', 'close')
        proxy_handler = urllib2.ProxyHandler({'http': '%s:%s' % ('127.0.0.1', sets.LPORT + 1)})
        opener = urllib2.build_opener(proxy_handler)
        urllib2.install_opener(opener)
        try:
            resp = urllib2.urlopen(request, params)
        except urllib2.HTTPError, e:
            if e.code == 404:
                self.send_error(404, 'Fetchserver not found at the URL you specified.')
            elif e.code == 502:
                self.send_error(502, 'Transmission error, or the fetchserver is too busy.')
            else:
                self.send_error(e.code, 'Unknown error.')
            self.connection.close()
            return

        line = resp.readline()
        words = line.split()
        status = int(words[1])
        reason = ' '.join(words[2:])
        if status == 592 and method == 'GET':
            self.processLargeResponse(path)
            self.connection.close()
            return
        try:
            self.send_response(status, reason)
        except socket.error, (err, _):
            if err == errno.EPIPE or err == 10053:
                return
            else:
                raise

        text_content = True
        while True:
            line = resp.readline().strip()
            if line == '':
                break
            name, _, value = line.partition(':')
            name = name.strip()
            value = value.strip()
            if name.lower() == 'accept-ranges':
                continue
            self.send_header(name, value)
            if name.lower() == 'content-type':
                if value.lower().find('text') == -1:
                    text_content = False

        self.send_header('Accept-Ranges', 'none')
        self.end_headers()
        if text_content:
            data = resp.read()
            if len(data) > 0:
                self.wfile.write(zlib.decompress(data))
        else:
            while True:
                data = resp.read(sets.SBUFF)
                if data:
                    self.wfile.write(data)
                else:
                    break

        self.connection.close()

    def processLargeResponse(self, path):
        cur_pos = 0
        part_length = 1048576
        first_part = True
        content_length = 0
        text_content = True
        allowed_failed = 10
        while allowed_failed > 0:
            next_pos = 0
            self.headers['Range'] = 'bytes=%d-%d' % (cur_pos, cur_pos + part_length - 1)
            auth_data = '%s by %s' % (ServerInfo.Info('name').get_info(), ServerInfo.Info('by').get_info())
            params = urllib.urlencode({'method': 'GET',
             'encoded_path': base64.b64encode(path),
             'headers': base64.b64encode(str(self.headers)),
             'postdata': base64.b64encode(''),
             'authdata': base64.b64encode(auth_data),
             'version': sets.GAPPVER})
            request = urllib2.Request('http://%s' % sets.GAPPSVR)
            request.add_header('Accept-Encoding', 'identity, *;q=0')
            request.add_header('Connection', 'close')
            proxy_handler = urllib2.ProxyHandler({'http': '%s:%s' % ('127.0.0.1', sets.LPORT + 1)})
            opener = urllib2.build_opener(proxy_handler)
            urllib2.install_opener(opener)
            resp = urllib2.urlopen(request, params)
            line = resp.readline()
            words = line.split()
            status = int(words[1])
            if status != 206:
                if part_length > 65536:
                    part_length /= 2
                allowed_failed -= 1
                continue
            if first_part:
                self.send_response(200, 'OK')
                while True:
                    line = resp.readline().strip()
                    if line == '':
                        break
                    name, _, value = line.partition(':')
                    name = name.strip()
                    value = value.strip()
                    nl = name.lower()
                    if nl == 'content-range':
                        m = re.match('bytes[ \\t]+([0-9]+)-([0-9]+)/([0-9]+)', value)
                        if not m or int(m.group(1)) != cur_pos:
                            return
                        next_pos = int(m.group(2)) + 1
                        content_length = int(m.group(3))
                        continue
                    elif nl == 'content-length':
                        continue
                    elif nl == 'accept-ranges':
                        continue
                    self.send_header(name, value)
                    if nl == 'content-type':
                        if value.lower().find('text') == -1:
                            text_content = False

                if content_length == 0:
                    return
                self.send_header('Content-Length', content_length)
                self.send_header('Accept-Ranges', 'none')
                self.end_headers()
                first_part = False
            else:
                while True:
                    line = resp.readline().strip()
                    if line == '':
                        break
                    name, _, value = line.partition(':')
                    name = name.strip()
                    value = value.strip()
                    if name.lower() == 'content-range':
                        m = re.match('bytes[ \\t]+([0-9]+)-([0-9]+)/([0-9]+)', value)
                        if not m or int(m.group(1)) != cur_pos:
                            return
                        next_pos = int(m.group(2)) + 1
                        continue

            if text_content:
                data = resp.read()
                if len(data) > 0:
                    self.wfile.write(zlib.decompress(data))
            else:
                while True:
                    data = resp.read(sets.SBUFF)
                    if data:
                        self.wfile.write(data)
                    else:
                        break

            if next_pos == content_length:
                return
            cur_pos = next_pos


class ThreadingHTTPServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
    pass


class HTTPProxyService():

    def __init__(self):
        self.misc = ServerMisc.Execution()
        if sets.GAPPSVR:
            self.httpd = ThreadingHTTPServer((sets.LHOST, sets.LPORT), ProxyHandler)
        else:
            self.httpd = ThreadingHTTPServer((sets.LHOST, sets.LPORT + 1), ProxyHandler)
        self.httpd.allow_reuse_address = True

    def serve_forever(self):
        self.httpd.serve_forever()
          
