#Embedded file name: D:\InunxLABS\PythonS60\SimpleServer\version\full\ext\1.02.76_234524\ServerMainUI.py
import os
import sys
import e32
import socket
import random
import appuifw
#import btsocket
import threading
import ServerInfo
import ServerLogger
import ServerConfig
import ServerDaemon
import ServerHandler
import ServerPinger
import ServerPublicIP
import SocketServer
import sysinfo
ru = lambda text: text.decode('utf-8', 'ignore')
ur = lambda text: text.encode('utf-8', 'ignore')
tr = False

class Validate:

    def __init__(self):
        self.sets = ServerConfig.Sets()
        self.imei = '358627047615933'
        self.key = self.key()
        self.dev = self.dev()

    def key(self):
        try:
            return open(ru('%s.key' % self.imei), 'rb').read()
        except:
            return ''

    def dev(self):    
        return 1
        

    def trial(self, fl = True):
        global tr
        tr = fl

    def test(self):
        if tr:
            return 1
        else:
            try:
                return SocketServer.ServerValidation(self.imei, self.key, self.dev).validate()
            except:
                return 0


class MainUI:

    def __init__(self):
        self.startup = True
        self.restart = False
        self.key_val = Validate()
        self.sets = ServerConfig.Sets()
        self.daemon = ServerDaemon.DaemonStart()
        self.timek = e32.Ao_timer()
        self.timet = e32.Ao_timer()
        self.timew = e32.Ao_timer()
        self.sleep = e32.ao_sleep
        self.t_keep = 30
        self.t_time = 0.05
        self.t_sleep = 0.25
        self.t_log = 300
        self.screen_list = [ru('Normal'), ru('Large')]
        self.noyes_list = [ru('No'), ru('Yes')]
        self.version_list = [ru('Default'), ru('HTTP/1.0'), ru('HTTP/1.1')]
        self.method_list = [ru('HEAD'),
         ru('GET'),
         ru('POST'),
         ru('DELETE'),
         ru('CONNECT'),
         ru('OPTIONS'),
         ru('TRACE'),
         ru('PUT')]
        self.line_list = [ru('\\r\\n'), ru('\\n')]
        self.split_list = [ru('Default'),
         ru('Newline x1'),
         ru('Newline x2'),
         ru('Newline x3'),
         ru('Newline x4'),
         ru('Newline x5')]

    def exit_app(self):
        self.timek.cancel()
        self.timet.cancel()
        self.timew.cancel()
        appuifw.app.title = ru('Closing...')
        self.sleep(1)
        os.abort()

    def exit_ask(self):
        if appuifw.query(ru('Exit %s?' % ServerInfo.Info('name').get_info()), 'query'):
            self.exit_app()

    def about_app(self):
        appuifw.note(ru('%s v%s\n%s\n%s\n\xc2\xa9%s %s' % (ServerInfo.Info('name').get_info(),
         ServerInfo.Info('ver').get_info(),
         ServerInfo.Info('about').get_info(),
         ServerInfo.Info('mail').get_info(),
         ServerInfo.Info('date').get_info().split('/')[2],
         ServerInfo.Info('by').get_info())), 'info')

    def restart_app(self):
        if self.sets.WARN < 10:
            self.sets.WARN += 1
            self.sets.save()
            appuifw.note(ru('Please restart application for better performance...'), 'info')

    def abort_app(self):
        appuifw.note(ru('Unhandled lost connection, application need to be restarted!'), 'error')
        self.exit_app()

    def update_app(self):
        appuifw.note(ru('Updating configuration...'), 'info')

    def testip_app(self):
        try:
            httpd = threading.Thread(target=ServerPublicIP.GetPublicIP().check, args=())
            httpd.daemon = True
            httpd.start()
        except:
            pass

    def title_app(self, text):
        appuifw.app.title = text[self.count:]
        self.timet.cancel()
        self.count += 1
        if self.count > len(text) + 1:
            self.count = 0
            appuifw.app.title = ru('%s (%s)' % (ServerInfo.Info('name').get_info(), self.sets.DEFCFG))
        else:
            self.timet.after(self.t_time, lambda : self.title_app(text))

    def refresh_server(self):
        self.restart = True
        self.sets_app(True)

    def body_app(self, text):
        self.timet.cancel()
        self.timew.cancel()
        appuifw.app.orientation = 'automatic'
        self.key_val = Validate()
        if text == False:
            appuifw.app.title = ru('%s (%s)' % (ServerInfo.Info('name').get_info(), self.sets.DEFCFG))
            ServerHandler.LogWindow(True)
            ServerPublicIP.LogWindow(True)
            self.bodi_text = ServerLogger.Console(True)
            appuifw.app.body = self.bodi_text.text
            sys.stderr = sys.stdout = self.bodi_text
            log_menu = [(ru('TestIP'), lambda : self.testip_app()), (ru('About'), lambda : self.about_app()), (ru('Back'), lambda : self.body_app(True))]
            if self.key_val.test() == 2:
                log_menu = [(ru('Generate'), lambda : self.gen_app())] + log_menu
            appuifw.app.menu = log_menu
            appuifw.app.exit_key_handler = lambda : self.body_app(True)
            self.timew.after(self.t_log, lambda : self.body_app(True))
        elif text == True:
            appuifw.app.title = ru('Please wait...')
            ServerHandler.LogWindow(False)
            ServerPublicIP.LogWindow(False)
            self.bodi_text = ServerLogger.Console(False)
            appuifw.app.body = self.bodi_text.text
            sys.stderr = sys.stdout = self.bodi_text
            appuifw.app.menu = []
            appuifw.app.exit_key_handler = lambda : appuifw.note(ru('Please wait...'), 'info')
            if self.startup:
                self.startup = False
                self.sleep(self.t_sleep)
            else:
                i = 0
                while i < 5:
                    self.bodi_text.clear()
                    self.sleep(self.t_sleep)
                    i += 1

            self.sets_app(False)
        else:
            ServerHandler.LogWindow(False)
            ServerPublicIP.LogWindow(False)
            appuifw.app.title = self.cur_cfg
            self.bodi_text = appuifw.Text()
            appuifw.app.body = self.bodi_text
            self.bodi_text.font = ('title', 18, None)
            self.bodi_text.color = 0
            self.bodi_text.add(text)
            appuifw.app.menu = [(ru('Back'), lambda : self.text_asc((self.sub_list, self.cur_list)))]
            appuifw.app.exit_key_handler = lambda : self.text_asc((self.sub_list, self.cur_list))
        return None

    def viewer_app(self):
        appuifw.app.orientation = 'automatic'
        appuifw.app.title = ru('[ %s ]' % self.sets.DEFCFG)
        self.bodi_text = appuifw.Text()
        appuifw.app.body = self.bodi_text
        self.bodi_text.font = ('title', 14, None)
        self.bodi_text.color = 0
        self.bodi_text.add(ru('Access Point :\n'))
        self.bodi_text.add(ru('- %s\n' % self.access_list[self.cur_point]))
        self.bodi_text.add(ru('Local Host :\n'))
        self.bodi_text.add(ru('- %s\n' % self.sets.LHOST))
        self.bodi_text.add(ru('Local Port :\n'))
        self.bodi_text.add(ru('- %s\n' % str(self.sets.LPORT)))
        self.bodi_text.add(ru('HTTP Query :\n'))
        self.bodi_text.add(ru('- Front Query : %s\n' % self.subs_app(self.sets.FQUERY)))
        self.bodi_text.add(ru('- Middle Query : %s\n' % self.subs_app(self.sets.MQUERY)))
        self.bodi_text.add(ru('- Back Query : %s\n' % self.subs_app(self.sets.BQUERY)))
        self.bodi_text.add(ru('- Reverse Query : %s\n' % self.subs_app(self.sets.RQUERY)))
        self.bodi_text.add(ru('- Inject Query : %s\n' % self.subs_app(self.sets.IQUERY)))
        self.bodi_text.add(ru('- Inject Method : %s\n' % self.method_list[self.sets.IMETHOD]))
        self.bodi_text.add(ru('- Inject Newline : %s\n' % self.line_list[self.sets.ILINE]))
        self.bodi_text.add(ru('- Inject Splitline : %s\n' % self.split_list[self.sets.ISPLIT]))
        self.bodi_text.add(ru('HTTP Header :\n'))
        self.bodi_text.add(ru('- Custom Header 1 : %s\n' % self.subs_app(self.sets.CUSHDR0)))
        self.bodi_text.add(ru('- Header Value 1 : %s\n' % self.subs_app(self.sets.VALHDR0)))
        self.bodi_text.add(ru('- Custom Header 2 : %s\n' % self.subs_app(self.sets.CUSHDR1)))
        self.bodi_text.add(ru('- Header Value 2 : %s\n' % self.subs_app(self.sets.VALHDR1)))
        self.bodi_text.add(ru('- Custom Header 3 : %s\n' % self.subs_app(self.sets.CUSHDR2)))
        self.bodi_text.add(ru('- Header Value 3 : %s\n' % self.subs_app(self.sets.VALHDR2)))
        self.bodi_text.add(ru('- Custom Header 4 : %s\n' % self.subs_app(self.sets.CUSHDR3)))
        self.bodi_text.add(ru('- Header Value 4 : %s\n' % self.subs_app(self.sets.VALHDR3)))
        self.bodi_text.add(ru('Server Config :\n'))
        self.bodi_text.add(ru('- Fetch Server : %s\n' % self.subs_app(self.sets.GAPPSVR)))
        self.bodi_text.add(ru('- Keep Server : %s\n' % self.subs_app(self.sets.KEEP)))
        self.bodi_text.add(ru('- Url Replacer : %s\n' % self.subs_app(self.sets.CQUERY)))
        self.bodi_text.add(ru('- Request Version : %s\n' % self.version_list[self.sets.RHTTP]))
        self.bodi_text.add(ru('- Advanced Mode : %s\n' % self.noyes_list[self.sets.ADMODE]))
        self.bodi_text.add(ru('- Tunnel Proxy : %s\n' % self.noyes_list[self.sets.PTYPE]))
        self.bodi_text.add(ru('- Server Buffer : %s\n' % str(self.sets.SBUFF)))
        self.bodi_text.add(ru('- Screen Size : %s\n' % self.screen_list[self.sets.SCREEN]))
        self.bodi_text.add(ru('Proxy Host :\n'))
        self.bodi_text.add(ru('- %s\n' % self.subs_app(self.sets.PHOST)))
        self.bodi_text.add(ru('Proxy Port :\n'))
        self.bodi_text.add(ru('- %s\n' % str(self.sets.PPORT)))
        self.bodi_text.set_pos(0)
        self.cur_list = self.sett_list.current()
        appuifw.app.menu = [(ru('Back'), lambda : self.sets_app(False, self.cur_list))]
        appuifw.app.exit_key_handler = lambda : self.sets_app(False, self.cur_list)
        return None

    def text_asc(self, sets_cur):
        try:
            ur(self.bodi_text.get()).decode('ascii')
            self.text_get(sets_cur)
        except:
            appuifw.note(ru('Invalid charset!'), 'error')

    def text_get(self, sets_cur):
        if sets_cur == (0, 6):
            config_sav = (self.sets.PHOST, self.sets.PPORT)
            if self.sets.PHOST != ur(self.bodi_text.get()):
                self.sets.PHOST = ur(self.bodi_text.get()).split('/', 1)[0].lower().replace(' ', '').replace('localhost', '127.0.0.1').replace('0.0.0.0', '127.0.0.1')
                if ':' in self.sets.PHOST or '>' in self.sets.PHOST or '@' in self.sets.PHOST or not self.sets.PHOST:
                    if '%s:%s' % (self.sets.LHOST, self.sets.LPORT) in self.sets.PHOST:
                        self.sets.PHOST = self.sets.PHOST.replace('%s:%s' % (self.sets.LHOST, self.sets.LPORT), '')
                    if self.sets.PHOST.startswith('>'):
                        self.sets.PHOST = self.sets.PHOST[1:]
                    elif self.sets.PHOST.endswith('>'):
                        self.sets.PHOST = self.sets.PHOST[:len(self.sets.PHOST) - 1]
                    self.sets.PPORT = 0
                if self.sets.LHOST == self.sets.PHOST and self.sets.LPORT == self.sets.PPORT:
                    self.sets.PHOST = ''
                    self.sets.PPORT = 0
                if not self.sets.PHOST:
                    self.sets.PTYPE = 0
                self.sets.save()
            config_chg = (self.sets.PHOST, self.sets.PPORT)
            if config_sav != config_chg:
                self.sets_app(True, self.cur_list)
            else:
                self.sets_app(False, self.cur_list)
            del config_sav
            del config_chg
        if sets_cur in ((1, 0),
         (1, 1),
         (1, 2),
         (1, 3),
         (1, 4)):
            config_sav = (self.sets.FQUERY,
             self.sets.MQUERY,
             self.sets.BQUERY,
             self.sets.RQUERY,
             self.sets.IQUERY)
            if sets_cur == (1, 0):
                if self.sets.FQUERY != ur(self.bodi_text.get()):
                    self.sets.FQUERY = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (1, 1):
                if self.sets.MQUERY != ur(self.bodi_text.get()):
                    self.sets.MQUERY = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (1, 2):
                if self.sets.BQUERY != ur(self.bodi_text.get()):
                    self.sets.BQUERY = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (1, 3):
                if self.sets.RQUERY != ur(self.bodi_text.get()):
                    self.sets.RQUERY = ur(self.bodi_text.get()).split('/')[0].lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (1, 4):
                if self.sets.IQUERY != ur(self.bodi_text.get()):
                    self.sets.IQUERY = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            config_chg = (self.sets.FQUERY,
             self.sets.MQUERY,
             self.sets.BQUERY,
             self.sets.RQUERY,
             self.sets.IQUERY)
            if config_sav != config_chg:
                self.subedit_app((0, 3), self.cur_list, True)
            else:
                self.subedit_app((0, 3), self.cur_list, False)
            del config_sav
            del config_chg
        if sets_cur in ((2, 0),
         (2, 1),
         (2, 2),
         (2, 3),
         (2, 4),
         (2, 5),
         (2, 6),
         (2, 7)):
            config_sav = (self.sets.CUSHDR0,
             self.sets.VALHDR0,
             self.sets.CUSHDR1,
             self.sets.VALHDR1,
             self.sets.CUSHDR2,
             self.sets.VALHDR2,
             self.sets.CUSHDR3,
             self.sets.VALHDR3)
            if sets_cur == (2, 0):
                if self.sets.CUSHDR0 != ur(self.bodi_text.get()):
                    self.sets.CUSHDR0 = ur(self.bodi_text.get()).title().replace(' ', '')
                    if not self.sets.CUSHDR0:
                        self.sets.VALHDR0 = ''
                    self.sets.save()
            if sets_cur == (2, 1):
                if self.sets.VALHDR0 != ur(self.bodi_text.get()):
                    self.sets.VALHDR0 = ur(self.bodi_text.get())
                    self.sets.save()
            if sets_cur == (2, 2):
                if self.sets.CUSHDR1 != ur(self.bodi_text.get()):
                    self.sets.CUSHDR1 = ur(self.bodi_text.get()).title().replace(' ', '')
                    if not self.sets.CUSHDR1:
                        self.sets.VALHDR1 = ''
                    self.sets.save()
            if sets_cur == (2, 3):
                if self.sets.VALHDR1 != ur(self.bodi_text.get()):
                    self.sets.VALHDR1 = ur(self.bodi_text.get())
                    self.sets.save()
            if sets_cur == (2, 4):
                if self.sets.CUSHDR2 != ur(self.bodi_text.get()):
                    self.sets.CUSHDR2 = ur(self.bodi_text.get()).title().replace(' ', '')
                    if not self.sets.CUSHDR2:
                        self.sets.VALHDR2 = ''
                    self.sets.save()
            if sets_cur == (2, 5):
                if self.sets.VALHDR2 != ur(self.bodi_text.get()):
                    self.sets.VALHDR2 = ur(self.bodi_text.get())
                    self.sets.save()
            if sets_cur == (2, 6):
                if self.sets.CUSHDR3 != ur(self.bodi_text.get()):
                    self.sets.CUSHDR3 = ur(self.bodi_text.get()).title().replace(' ', '')
                    if not self.sets.CUSHDR3:
                        self.sets.VALHDR3 = ''
                    self.sets.save()
            if sets_cur == (2, 7):
                if self.sets.VALHDR3 != ur(self.bodi_text.get()):
                    self.sets.VALHDR3 = ur(self.bodi_text.get())
                    self.sets.save()
            config_chg = (self.sets.CUSHDR0,
             self.sets.VALHDR0,
             self.sets.CUSHDR1,
             self.sets.VALHDR1,
             self.sets.CUSHDR2,
             self.sets.VALHDR2,
             self.sets.CUSHDR3,
             self.sets.VALHDR3)
            if config_sav != config_chg:
                self.subedit_app((0, 4), self.cur_list, True)
            else:
                self.subedit_app((0, 4), self.cur_list, False)
            del config_sav
            del config_chg
        if sets_cur in ((3, 0), (3, 1), (3, 2)):
            config_sav = (self.sets.GAPPSVR, self.sets.KEEP, self.sets.CQUERY)
            config_sgp = False
            if config_sav[0]:
                config_sgp = True
            if sets_cur == (3, 0):
                if self.sets.GAPPSVR != ur(self.bodi_text.get()):
                    self.sets.GAPPSVR = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (3, 1):
                if self.sets.KEEP != ur(self.bodi_text.get()):
                    self.sets.KEEP = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            if sets_cur == (3, 2):
                if self.sets.CQUERY != ur(self.bodi_text.get()):
                    self.sets.CQUERY = ur(self.bodi_text.get()).lower().replace(' ', '')
                    self.sets.save()
            config_chg = (self.sets.GAPPSVR, self.sets.KEEP, self.sets.CQUERY)
            config_cgp = False
            if config_chg[0]:
                config_cgp = True
            if config_sav != config_chg:
                if config_sgp != config_cgp:
                    self.restart = True
                    self.restart_app()
                self.subedit_app((0, 5), self.cur_list, True)
            else:
                self.subedit_app((0, 5), self.cur_list, False)
            del config_sav
            del config_chg
            del config_sgp
            del config_cgp

    def subedit_app(self, sets_cur, focus = 0, change = False):
        appuifw.app.orientation = 'automatic'
        if sets_cur == (0, 3):
            appuifw.app.title = ru('HTTP Query :')
            self.cfg_list = [ru('Front Query :'),
             ru('Middle Query :'),
             ru('Back Query :'),
             ru('Reverse Query :'),
             ru('Inject Query :'),
             ru('Inject Method :'),
             ru('Inject Newline :'),
             ru('Inject Splitline :')]
            self.lbox_list([(self.cfg_list[0], ru(self.subs_app(self.sets.FQUERY))),
             (self.cfg_list[1], ru(self.subs_app(self.sets.MQUERY))),
             (self.cfg_list[2], ru(self.subs_app(self.sets.BQUERY))),
             (self.cfg_list[3], ru(self.subs_app(self.sets.RQUERY))),
             (self.cfg_list[4], ru(self.subs_app(self.sets.IQUERY))),
             (self.cfg_list[5], ru(self.method_list[self.sets.IMETHOD])),
             (self.cfg_list[6], ru(self.line_list[self.sets.ILINE])),
             (self.cfg_list[7], ru(self.split_list[self.sets.ISPLIT]))], focus)
            self.sub_list = 1
            self.cur_list = None
        if sets_cur == (0, 4):
            appuifw.app.title = ru('HTTP Header :')
            self.cfg_list = [ru('Add/Del/Rep Header 1 :'),
             ru('Add/Rep Header Value 1 :'),
             ru('Add/Del/Rep Header 2 :'),
             ru('Add/Rep Header Value 2 :'),
             ru('Add/Del/Rep Header 3 :'),
             ru('Add/Rep Header Value 3 :'),
             ru('Add/Del/Rep Header 4 :'),
             ru('Add/Rep Header Value 4 :')]
            self.lbox_list([(self.cfg_list[0], ru(self.subs_app(self.sets.CUSHDR0))),
             (self.cfg_list[1], ru(self.subs_app(self.sets.VALHDR0))),
             (self.cfg_list[2], ru(self.subs_app(self.sets.CUSHDR1))),
             (self.cfg_list[3], ru(self.subs_app(self.sets.VALHDR1))),
             (self.cfg_list[4], ru(self.subs_app(self.sets.CUSHDR2))),
             (self.cfg_list[5], ru(self.subs_app(self.sets.VALHDR2))),
             (self.cfg_list[6], ru(self.subs_app(self.sets.CUSHDR3))),
             (self.cfg_list[7], ru(self.subs_app(self.sets.VALHDR3)))], focus)
            self.sub_list = 2
            self.cur_list = None
        if sets_cur == (0, 5):
            appuifw.app.title = ru('Server Config :')
            self.cfg_list = [ru('Fetch Server :'),
             ru('Keep Server :'),
             ru('Url Replacer :'),
             ru('Request Version :'),
             ru('Advanced Mode :'),
             ru('Tunnel Proxy :'),
             ru('Server Buffer :'),
             ru('Screen Size :')]
            self.lbox_list([(self.cfg_list[0], ru(self.subs_app(self.sets.GAPPSVR))),
             (self.cfg_list[1], ru(self.subs_app(self.sets.KEEP))),
             (self.cfg_list[2], ru(self.subs_app(self.sets.CQUERY))),
             (self.cfg_list[3], ru(self.version_list[self.sets.RHTTP])),
             (self.cfg_list[4], ru(self.noyes_list[self.sets.ADMODE])),
             (self.cfg_list[5], ru(self.noyes_list[self.sets.PTYPE])),
             (self.cfg_list[6], ru(str(self.sets.SBUFF))),
             (self.cfg_list[7], ru(self.screen_list[self.sets.SCREEN]))], focus)
            self.sub_list = 3
            self.cur_list = None
        if change:
            appuifw.app.menu = [(ru('Back'), lambda : self.sets_app(True, sets_cur[1]))]
            appuifw.app.exit_key_handler = lambda : self.sets_app(True, sets_cur[1])
        else:
            appuifw.app.menu = [(ru('Back'), lambda : self.sets_app(False, sets_cur[1]))]
            appuifw.app.exit_key_handler = lambda : self.sets_app(False, sets_cur[1])
        return

    def edit_app(self):
        self.timet.cancel()
        self.timew.cancel()
        self.cur_list = self.sett_list.current()
        self.cur_cfg = self.cfg_list[self.cur_list]
        if self.sub_list == 0:
            appuifw.app.title = ru('%s (%s)' % (ServerInfo.Info('name').get_info(), self.sets.DEFCFG))
            if self.cur_list == 0:
                edit_cfg = appuifw.popup_menu(self.access_list, self.cur_cfg)
                if edit_cfg != None and self.sets.APN != int(self.point_list[edit_cfg]):
                    self.sets.APN = int(self.point_list[edit_cfg])
                    self.cur_point = self.point_list.index(self.sets.APN)
                    if self.sets.APN == -1:
                        self.sets.KEEP = ''
                    self.restart = True
                    self.sets.save()
                    self.sets_app(True, self.cur_list)
            if self.cur_list == 1:
                edit_cfg = appuifw.query(self.cur_cfg, 'text', ru(self.sets.LHOST))
                if edit_cfg != None and len(edit_cfg.split('.')) == 4 and len(edit_cfg) >= 7 and edit_cfg != self.sets.LHOST:
                    edit_cfg = ur(edit_cfg).lower().replace(' ', '')
                    for digit in edit_cfg:
                        if not str(digit).isdigit() and str(digit) != '.':
                            edit_cfg = None
                            break

                    if edit_cfg:
                        self.sets.LHOST = edit_cfg
                        self.restart = True
                        self.sets.save()
                        self.restart_app()
                        self.sets_app(True, self.cur_list)
            if self.cur_list == 2:
                edit_cfg = appuifw.query(self.cur_cfg, 'number', self.sets.LPORT)
                if edit_cfg != None and edit_cfg != self.sets.LPORT:
                    if edit_cfg < 80:
                        edit_cfg = 80
                    if edit_cfg > 65534:
                        edit_cfg = 65534
                    if self.sets.LHOST != self.sets.PHOST or edit_cfg != self.sets.PPORT:
                        self.sets.LPORT = edit_cfg
                        self.restart = True
                        self.sets.save()
                        self.restart_app()
                        self.sets_app(True, self.cur_list)
            if self.cur_list in (3, 4, 5):
                self.subedit_app((self.sub_list, self.cur_list), 0, False)
            if self.cur_list == 6:
                self.body_app(ru(self.sets.PHOST))
            if self.cur_list == 7:
                if ':' in self.sets.PHOST or '>' in self.sets.PHOST or '@' in self.sets.PHOST or not self.sets.PHOST:
                    appuifw.note(ru('Invalid proxy host'), 'info')
                else:
                    edit_cfg = appuifw.query(self.cur_cfg, 'number', self.sets.PPORT)
                    if edit_cfg != None and edit_cfg != self.sets.PPORT:
                        if edit_cfg < 80 and edit_cfg != 0:
                            edit_cfg = 80
                        if edit_cfg > 65535:
                            edit_cfg = 65535
                        if self.sets.LHOST != self.sets.PHOST or self.sets.LPORT != edit_cfg:
                            self.sets.PPORT = edit_cfg
                            self.sets.save()
                            self.sets_app(True, self.cur_list)
        if self.sub_list == 1:
            if self.cur_list in (0, 1, 2, 3, 4):
                if self.cur_list == 0:
                    self.body_app(ru(self.sets.FQUERY))
                if self.cur_list == 1:
                    self.body_app(ru(self.sets.MQUERY))
                if self.cur_list == 2:
                    self.body_app(ru(self.sets.BQUERY))
                if self.cur_list == 3:
                    self.body_app(ru(self.sets.RQUERY))
                if self.cur_list == 4:
                    self.body_app(ru(self.sets.IQUERY))
            if self.cur_list in (5, 6, 7):
                config_sav = (self.sets.IMETHOD, self.sets.ILINE, self.sets.ISPLIT)
                if self.cur_list == 5:
                    if self.sets.IQUERY:
                        edit_cfg = appuifw.popup_menu(self.method_list, self.cur_cfg)
                        if edit_cfg != None and edit_cfg != self.sets.IMETHOD:
                            self.sets.IMETHOD = edit_cfg
                            self.sets.save()
                    else:
                        appuifw.note(ru('Inject query needed!'), 'info')
                if self.cur_list == 6:
                    if self.sets.IQUERY:
                        edit_cfg = appuifw.popup_menu(self.line_list, self.cur_cfg)
                        if edit_cfg != None and edit_cfg != self.sets.ILINE:
                            self.sets.ILINE = edit_cfg
                            self.sets.save()
                    else:
                        appuifw.note(ru('Inject query needed!'), 'info')
                if self.cur_list == 7:
                    if self.sets.IQUERY:
                        edit_cfg = appuifw.popup_menu(self.split_list, self.cur_cfg)
                        if edit_cfg != None and edit_cfg != self.sets.ISPLIT:
                            self.sets.ISPLIT = edit_cfg
                            self.sets.save()
                    else:
                        appuifw.note(ru('Inject query needed!'), 'info')
                config_chg = (self.sets.IMETHOD, self.sets.ILINE, self.sets.ISPLIT)
                if config_sav != config_chg:
                    self.subedit_app((0, 3), self.cur_list, True)
                del config_sav
                del config_chg
        if self.sub_list == 2:
            if self.cur_list == 0:
                self.body_app(ru(self.sets.CUSHDR0))
            if self.cur_list == 1:
                if self.sets.CUSHDR0:
                    self.body_app(ru(self.sets.VALHDR0))
                else:
                    appuifw.note(ru('Header 1 needed!'), 'info')
            if self.cur_list == 2:
                self.body_app(ru(self.sets.CUSHDR1))
            if self.cur_list == 3:
                if self.sets.CUSHDR1:
                    self.body_app(ru(self.sets.VALHDR1))
                else:
                    appuifw.note(ru('Header 2 needed!'), 'info')
            if self.cur_list == 4:
                self.body_app(ru(self.sets.CUSHDR2))
            if self.cur_list == 5:
                if self.sets.CUSHDR2:
                    self.body_app(ru(self.sets.VALHDR2))
                else:
                    appuifw.note(ru('Header 3 needed!'), 'info')
            if self.cur_list == 6:
                self.body_app(ru(self.sets.CUSHDR3))
            if self.cur_list == 7:
                if self.sets.CUSHDR3:
                    self.body_app(ru(self.sets.VALHDR3))
                else:
                    appuifw.note(ru('Header 4 needed!'), 'info')
        if self.sub_list == 3:
            if self.cur_list in (0, 1, 2):
                if self.cur_list == 0:
                    self.body_app(ru(self.sets.GAPPSVR))
                if self.cur_list == 1:
                    if self.sets.APN != -1:
                        self.body_app(ru(self.sets.KEEP))
                    else:
                        appuifw.note(ru('Access point needed!'), 'info')
                if self.cur_list == 2:
                    self.body_app(ru(self.sets.CQUERY))
            if self.cur_list in (3, 4, 5, 6, 7):
                config_sav = (self.sets.RHTTP,
                 self.sets.ADMODE,
                 self.sets.PTYPE,
                 self.sets.SBUFF,
                 self.sets.SCREEN)
                if self.cur_list == 3:
                    edit_cfg = appuifw.popup_menu(self.version_list, self.cur_cfg)
                    if edit_cfg != None and edit_cfg != self.sets.RHTTP:
                        self.sets.RHTTP = edit_cfg
                        self.sets.save()
                if self.cur_list == 4:
                    edit_cfg = appuifw.popup_menu(self.noyes_list, self.cur_cfg)
                    if edit_cfg != None and edit_cfg != self.sets.ADMODE:
                        self.sets.ADMODE = edit_cfg
                        self.sets.save()
                if self.cur_list == 5:
                    if self.sets.PHOST:
                        edit_cfg = appuifw.popup_menu(self.noyes_list, self.cur_cfg)
                        if edit_cfg != None and edit_cfg != self.sets.PTYPE:
                            self.sets.PTYPE = edit_cfg
                            self.sets.save()
                    else:
                        appuifw.note(ru('Proxy needed!'), 'info')
                if self.cur_list == 6:
                    edit_cfg = appuifw.query(self.cur_cfg, 'number', self.sets.SBUFF)
                    if edit_cfg != None and edit_cfg != self.sets.SBUFF:
                        if edit_cfg < 512:
                            edit_cfg = 512
                        if edit_cfg > 32768:
                            edit_cfg = 32768
                        self.sets.SBUFF = edit_cfg
                        self.sets.save()
                if self.cur_list == 7:
                    edit_cfg = appuifw.popup_menu(self.screen_list, self.cur_cfg)
                    if edit_cfg != None and edit_cfg != self.sets.SCREEN:
                        self.sets.SCREEN = edit_cfg
                        self.sets.save()
                config_chg = (self.sets.RHTTP,
                 self.sets.ADMODE,
                 self.sets.PTYPE,
                 self.sets.SBUFF,
                 self.sets.SCREEN)
                if config_sav != config_chg:
                    self.subedit_app((0, 5), self.cur_list, True)
                del config_sav
                del config_chg
        return

    def lbox_list(self, items, focus = 0):
        self.sett_list = appuifw.Listbox(items, lambda : self.edit_app())
        appuifw.app.body = self.sett_list
        self.sett_list.set_list(items, focus)

    def load_app(self, config):
        if len(config) == 28 and ur(config[1].lower()) != '<empty>':
            config_sgp = False
            if self.sets.GAPPSVR:
                config_sgp = True
            self.sets.DEFCFG = config[1]
            self.sets.FQUERY = config[2]
            self.sets.MQUERY = config[3]
            self.sets.BQUERY = config[4]
            self.sets.RQUERY = config[5]
            self.sets.CQUERY = config[6]
            self.sets.IQUERY = config[7]
            self.sets.IMETHOD = config[8]
            self.sets.ILINE = config[9]
            self.sets.ISPLIT = config[10]
            self.sets.ADMODE = config[11]
            self.sets.RPORT = config[12]
            self.sets.CUSHDR0 = config[13]
            self.sets.VALHDR0 = config[14]
            self.sets.CUSHDR1 = config[15]
            self.sets.VALHDR1 = config[16]
            self.sets.CUSHDR2 = config[17]
            self.sets.VALHDR2 = config[18]
            self.sets.CUSHDR3 = config[19]
            self.sets.VALHDR3 = config[20]
            self.sets.GAPPSVR = config[21]
            self.sets.KEEP = config[22]
            self.sets.RHTTP = config[23]
            self.sets.RHTTPS = config[24]
            self.sets.PHOST = config[25]
            self.sets.PPORT = config[26]
            self.sets.PTYPE = config[27]
            self.sets.save()
            appuifw.note(ru('%s loaded!' % self.sets.DEFCFG), 'conf')
            config_cgp = False
            if self.sets.GAPPSVR:
                config_cgp = True
            if config_sgp != config_cgp:
                self.restart = True
                self.restart_app()
            del config_sgp
            del config_cgp
            self.sets_app(True)
        else:
            appuifw.note(ru('Invalid configuration!'), 'error')

    def save_app(self, config):
        edit_cfg = appuifw.query(ru('Save as'), 'text', ru(config[1]))
        if edit_cfg != None:
            try:
                edit_cfg = ur(edit_cfg.lower()).decode('ascii')
            except:
                edit_cfg = None

            if edit_cfg and edit_cfg != '<empty>':
                title_cfg = True
                title_list = (list(self.sets.SAVCFG0)[1],
                 list(self.sets.SAVCFG1)[1],
                 list(self.sets.SAVCFG2)[1],
                 list(self.sets.SAVCFG3)[1],
                 list(self.sets.SAVCFG4)[1],
                 list(self.sets.SAVCFG5)[1],
                 list(self.sets.SAVCFG6)[1],
                 list(self.sets.SAVCFG7)[1],
                 list(self.sets.SAVCFG8)[1],
                 list(self.sets.SAVCFG9)[1])
                if edit_cfg in title_list and edit_cfg != ru(config[1]):
                    title_cfg = False
                if title_cfg:
                    self.sets.DEFCFG = ur(edit_cfg)
                    save_tupple = (config[0],
                     self.sets.DEFCFG,
                     self.sets.FQUERY,
                     self.sets.MQUERY,
                     self.sets.BQUERY,
                     self.sets.RQUERY,
                     self.sets.CQUERY,
                     self.sets.IQUERY,
                     self.sets.IMETHOD,
                     self.sets.ILINE,
                     self.sets.ISPLIT,
                     self.sets.ADMODE,
                     self.sets.RPORT,
                     self.sets.CUSHDR0,
                     self.sets.VALHDR0,
                     self.sets.CUSHDR1,
                     self.sets.VALHDR1,
                     self.sets.CUSHDR2,
                     self.sets.VALHDR2,
                     self.sets.CUSHDR3,
                     self.sets.VALHDR3,
                     self.sets.GAPPSVR,
                     self.sets.KEEP,
                     self.sets.RHTTP,
                     self.sets.RHTTPS,
                     self.sets.PHOST,
                     self.sets.PPORT,
                     self.sets.PTYPE)
                    if config[0] == 0:
                        self.sets.SAVCFG0 = save_tupple
                    if config[0] == 1:
                        self.sets.SAVCFG1 = save_tupple
                    if config[0] == 2:
                        self.sets.SAVCFG2 = save_tupple
                    if config[0] == 3:
                        self.sets.SAVCFG3 = save_tupple
                    if config[0] == 4:
                        self.sets.SAVCFG4 = save_tupple
                    if config[0] == 5:
                        self.sets.SAVCFG5 = save_tupple
                    if config[0] == 6:
                        self.sets.SAVCFG6 = save_tupple
                    if config[0] == 7:
                        self.sets.SAVCFG7 = save_tupple
                    if config[0] == 8:
                        self.sets.SAVCFG8 = save_tupple
                    if config[0] == 9:
                        self.sets.SAVCFG9 = save_tupple
                    self.sets.save()
                    appuifw.note(ru('%s saved!' % self.sets.DEFCFG), 'conf')
                    self.sets_app(False)
                else:
                    appuifw.note(ru('%s config name\nalready exists!' % edit_cfg), 'error')
            elif edit_cfg == '<empty>':
                appuifw.note(ru('%s config name\nnot allowed!' % edit_cfg), 'error')
            else:
                appuifw.note(ru('Invalid charset!'), 'error')
        return

    def gen_app(self):
        edit_cfg = appuifw.query(ru('Input IMEI :'), 'text', ru(self.sets.IMEI))
        if edit_cfg != None:
            try:
                edit_cfg = ur(edit_cfg.lower().replace(' ', '').replace('/', '').replace('-', '')).decode('ascii')
            except:
                edit_cfg = None

            if edit_cfg:
                digit = True
                for d in edit_cfg:
                    if not d.isdigit():
                        digit = False
                        break

                if len(edit_cfg) == 15 and digit:
                    appuifw.note(ru('Generating registration\nkey...'), 'info')
                    reg_key = SocketServer.ServerValidation(edit_cfg, self.key_val.key, self.key_val.dev).validate()
                    gen_dir = 'e:/Upload/'
                    try:
                        try:
                            os.makedirs(gen_dir)
                        except:
                            pass

                        open(ru('%s%s.key' % (gen_dir, edit_cfg)), 'wb').write(reg_key)
                        self.sets.IMEI = edit_cfg
                        self.sets.save()
                        appuifw.note(ru('Generating successfully\n%s.key' % edit_cfg), 'conf')
                    except:
                        appuifw.note(ru('Generating failed\n%s.key' % edit_cfg), 'error')

                else:
                    appuifw.note(ru('Invalid IMEI'), 'error')
            else:
                appuifw.note(ru('Invalid charset!'), 'error')
        return

    def reset_app(self):
        config_sgp = False
        if self.sets.GAPPSVR:
            config_sgp = True
        self.sets.FQUERY = ''
        self.sets.MQUERY = ''
        self.sets.BQUERY = ''
        self.sets.RQUERY = ''
        self.sets.CQUERY = ''
        self.sets.IQUERY = ''
        self.sets.IMETHOD = 0
        self.sets.ILINE = 0
        self.sets.ISPLIT = 0
        self.sets.ADMODE = 0
        self.sets.RPORT = 0
        self.sets.CUSHDR0 = ''
        self.sets.VALHDR0 = ''
        self.sets.CUSHDR1 = ''
        self.sets.VALHDR1 = ''
        self.sets.CUSHDR2 = ''
        self.sets.VALHDR2 = ''
        self.sets.CUSHDR3 = ''
        self.sets.VALHDR3 = ''
        self.sets.GAPPSVR = ''
        self.sets.KEEP = ''
        self.sets.RHTTP = 0
        self.sets.RHTTPS = 1
        self.sets.PHOST = ''
        self.sets.PPORT = 0
        self.sets.PTYPE = 0
        self.sets.DEFCFG = 'default'
        self.sets.save()
        appuifw.note(ru('%s loaded!' % self.sets.DEFCFG), 'conf')
        config_cgp = False
        if self.sets.GAPPSVR:
            config_cgp = True
        if config_sgp != config_cgp:
            self.restart = True
            self.restart_app()
        del config_sgp
        del config_cgp
        self.sets_app(True)

    def failed_app(self):
        self.update_app()
        self.sets.APN = -1
        self.sets.KEEP = ''
        self.sets.save()
        self.sets_app(False)

    def apn_app(self):
        self.access_list = [ru('Default')]
        self.point_list = [-1]
        self.cur_point = 0
        try:
            #self.access_list += [ ru(name['name']) for name in btsocket.access_points() ]
            #self.point_list += [ point['iapid'] for point in btsocket.access_points() ]
            self.cur_point = self.point_list.index(self.sets.APN)
        except:
            self.sets.APN = -1
            self.sets.save()

    def pinger_app(self):
        try:
            httpd = threading.Thread(target=ServerPinger.Pinger().check, args=())
            httpd.daemon = True
            httpd.start()
        except:
            pass

    def keep_app(self):
        self.timek.cancel()
        if self.sets.APN != -1 and self.sets.KEEP:
            self.pinger_app()
            self.timek.after(random.randint(30, 300), lambda : self.keep_app())

    def dialer_app(self):
        self.timek.cancel()
        #btsocket.set_default_access_point(btsocket.access_point(self.sets.APN))
        if self.sets.APN != -1:
            try:
                socket.set_default_access_point(self.access_list[self.cur_point])
                self.keep_app()
            except:
                self.failed_app()

    def flag_app(self, flag):
        data = ''
        if flag == self.sets.DEFCFG:
            data = '\xe2\x80\xa2 '
        return data

    def subs_app(self, data = '', cut = False):
        if data:
            data = data
        else:
            data = 'None'
        if cut:
            if len(data) > 5:
                data = '%s...' % data[:5]
        return data

    def long_app(self, data):
        buff = ''
        for item in data:
            buff += '%s, ' % item

        data = buff[:len(buff) - 2]
        return data

    def sets_app(self, start = False, focus = 0):
        self.timet.cancel()
        self.timew.cancel()
        appuifw.app.screen = ur(self.screen_list[self.sets.SCREEN].lower())
        appuifw.app.orientation = 'automatic'
        appuifw.app.title = ru('%s (%s)' % (ServerInfo.Info('name').get_info(), self.sets.DEFCFG))
        appuifw.app.exit_key_handler = lambda : self.exit_ask()
        appuifw.app.menu = [(ru('Server'), ((ru('Refresh'), lambda : self.refresh_server()), (ru('Log'), lambda : self.body_app(False)))),
         (ru('Load'), ((ru(self.flag_app(list(self.sets.SAVCFG0)[1]) + list(self.sets.SAVCFG0)[1]), lambda : self.load_app(list(self.sets.SAVCFG0))),
           (ru(self.flag_app(list(self.sets.SAVCFG1)[1]) + list(self.sets.SAVCFG1)[1]), lambda : self.load_app(list(self.sets.SAVCFG1))),
           (ru(self.flag_app(list(self.sets.SAVCFG2)[1]) + list(self.sets.SAVCFG2)[1]), lambda : self.load_app(list(self.sets.SAVCFG2))),
           (ru(self.flag_app(list(self.sets.SAVCFG3)[1]) + list(self.sets.SAVCFG3)[1]), lambda : self.load_app(list(self.sets.SAVCFG3))),
           (ru(self.flag_app(list(self.sets.SAVCFG4)[1]) + list(self.sets.SAVCFG4)[1]), lambda : self.load_app(list(self.sets.SAVCFG4))),
           (ru(self.flag_app(list(self.sets.SAVCFG5)[1]) + list(self.sets.SAVCFG5)[1]), lambda : self.load_app(list(self.sets.SAVCFG5))),
           (ru(self.flag_app(list(self.sets.SAVCFG6)[1]) + list(self.sets.SAVCFG6)[1]), lambda : self.load_app(list(self.sets.SAVCFG6))),
           (ru(self.flag_app(list(self.sets.SAVCFG7)[1]) + list(self.sets.SAVCFG7)[1]), lambda : self.load_app(list(self.sets.SAVCFG7))),
           (ru(self.flag_app(list(self.sets.SAVCFG8)[1]) + list(self.sets.SAVCFG8)[1]), lambda : self.load_app(list(self.sets.SAVCFG8))),
           (ru(self.flag_app(list(self.sets.SAVCFG9)[1]) + list(self.sets.SAVCFG9)[1]), lambda : self.load_app(list(self.sets.SAVCFG9))))),
         (ru('Save'), ((ru(self.flag_app(list(self.sets.SAVCFG0)[1]) + list(self.sets.SAVCFG0)[1]), lambda : self.save_app(list(self.sets.SAVCFG0))),
           (ru(self.flag_app(list(self.sets.SAVCFG1)[1]) + list(self.sets.SAVCFG1)[1]), lambda : self.save_app(list(self.sets.SAVCFG1))),
           (ru(self.flag_app(list(self.sets.SAVCFG2)[1]) + list(self.sets.SAVCFG2)[1]), lambda : self.save_app(list(self.sets.SAVCFG2))),
           (ru(self.flag_app(list(self.sets.SAVCFG3)[1]) + list(self.sets.SAVCFG3)[1]), lambda : self.save_app(list(self.sets.SAVCFG3))),
           (ru(self.flag_app(list(self.sets.SAVCFG4)[1]) + list(self.sets.SAVCFG4)[1]), lambda : self.save_app(list(self.sets.SAVCFG4))),
           (ru(self.flag_app(list(self.sets.SAVCFG5)[1]) + list(self.sets.SAVCFG5)[1]), lambda : self.save_app(list(self.sets.SAVCFG5))),
           (ru(self.flag_app(list(self.sets.SAVCFG6)[1]) + list(self.sets.SAVCFG6)[1]), lambda : self.save_app(list(self.sets.SAVCFG6))),
           (ru(self.flag_app(list(self.sets.SAVCFG7)[1]) + list(self.sets.SAVCFG7)[1]), lambda : self.save_app(list(self.sets.SAVCFG7))),
           (ru(self.flag_app(list(self.sets.SAVCFG8)[1]) + list(self.sets.SAVCFG8)[1]), lambda : self.save_app(list(self.sets.SAVCFG8))),
           (ru(self.flag_app(list(self.sets.SAVCFG9)[1]) + list(self.sets.SAVCFG9)[1]), lambda : self.save_app(list(self.sets.SAVCFG9))))),
         (ru('Tools'), ((ru('Viewer'), lambda : self.viewer_app()), (ru('Reset'), lambda : self.reset_app()))),
         (ru('About'), lambda : self.about_app()),
         (ru('Exit'), lambda : self.exit_app())]
        self.apn_app()
        self.sub_list = 0
        self.cfg_list = [ru('Access Point :'),
         ru('Local Host :'),
         ru('Local Port :'),
         ru('HTTP Query :'),
         ru('HTTP Header :'),
         ru('Server Config :'),
         ru('Proxy Host :'),
         ru('Proxy Port :')]
        self.lbox_list([(self.cfg_list[0], ru(self.access_list[self.cur_point])),
         (self.cfg_list[1], ru(self.sets.LHOST)),
         (self.cfg_list[2], ru(str(self.sets.LPORT))),
         (self.cfg_list[3], ru(self.long_app((self.subs_app(self.sets.FQUERY, True),
           self.subs_app(self.sets.MQUERY, True),
           self.subs_app(self.sets.BQUERY, True),
           self.subs_app(self.sets.RQUERY, True),
           self.subs_app(self.sets.IQUERY, True),
           self.method_list[self.sets.IMETHOD],
           self.line_list[self.sets.ILINE],
           self.split_list[self.sets.ISPLIT])))),
         (self.cfg_list[4], ru(self.long_app((self.subs_app(self.sets.CUSHDR0, True),
           self.subs_app(self.sets.VALHDR0, True),
           self.subs_app(self.sets.CUSHDR1, True),
           self.subs_app(self.sets.VALHDR1, True),
           self.subs_app(self.sets.CUSHDR2, True),
           self.subs_app(self.sets.VALHDR2, True),
           self.subs_app(self.sets.CUSHDR3, True),
           self.subs_app(self.sets.VALHDR3, True))))),
         (self.cfg_list[5], ru(self.long_app((self.subs_app(self.sets.GAPPSVR, True),
           self.subs_app(self.sets.KEEP, True),
           self.subs_app(self.sets.CQUERY, True),
           self.version_list[self.sets.RHTTP],
           self.noyes_list[self.sets.ADMODE],
           self.noyes_list[self.sets.PTYPE],
           str(self.sets.SBUFF),
           self.screen_list[self.sets.SCREEN])))),
         (self.cfg_list[6], ru(self.subs_app(self.sets.PHOST))),
         (self.cfg_list[7], ru(str(self.sets.PPORT)))], focus)
        self.sleep(self.t_sleep)
        if start:
            appuifw.app.title = ru('Initializing...')
            self.sleep(self.t_sleep)
            self.start_server()

    def start_server(self):
        self.timek.cancel()
        self.timet.cancel()
        self.timew.cancel()
        config_sav = (self.sets.IMETHOD,
         self.sets.ILINE,
         self.sets.ISPLIT,
         self.sets.GAPPSVR,
         self.sets.KEEP,
         self.sets.PPORT,
         self.sets.PTYPE,
         self.sets.RHTTPS)
        if self.sets.APN != -1:
            self.dialer_app()
        else:
            self.sets.KEEP = ''
        if self.sets.GAPPSVR and self.sets.LHOST == self.sets.PHOST and self.sets.LPORT + 1 == self.sets.PPORT:
            self.sets.PPORT = self.sets.PPORT + 1
        if not self.sets.IQUERY:
            self.sets.IMETHOD = 0
            self.sets.ILINE = 0
            self.sets.ISPLIT = 0
        if not self.sets.PHOST:
            self.sets.PTYPE = 0
        if not self.sets.RHTTPS:
            self.sets.RHTTPS = 1
        self.sets.save()
        config_chg = (self.sets.IMETHOD,
         self.sets.ILINE,
         self.sets.ISPLIT,
         self.sets.GAPPSVR,
         self.sets.KEEP,
         self.sets.PPORT,
         self.sets.PTYPE,
         self.sets.RHTTPS)
        if config_sav != config_chg:
            self.update_app()
            self.sets_app(False)
        del config_sav
        del config_chg
        self.count = 0
        self.server_started()
        self.title_app(ru('Serving on %s:%s' % (str(self.sets.LHOST), str(self.sets.LPORT))))

    def server_started(self):
        self.daemon.start(self.restart)
        self.restart = False
