# Embedded file name: D:\InunxLABS\PythonS60\SimpleServer\version\full\ext\1.02.72_224636\e32.py
from e32 import *

class CapabilitySet:
    """This class enumerates all the capabilities present in TCapability class
    of symbian"""
    TCB, CommDD, PowerMgmt, MultimediaDD, ReadDeviceData, WriteDeviceData, DRM, TrustedUI, ProtServ, DiskAdmin, NetworkControl, AllFiles, SwEvent, NetworkServices, LocalServices, ReadUserData, WriteUserData, Location, SurroundingsDD, UserEnvironment, _None, _Denied = range(22)


def get_capabilities():

    def get_logicalname(value):
        for capas in dir(CapabilitySet):
            if getattr(CapabilitySet, capas) == value:
                return str(capas)

    capabilities = []
    tuple_of_capas = getcapability()
    for capas in tuple_of_capas:
        capabilities.append(get_logicalname(capas))

    result = tuple(capabilities)
    return result


def has_capabilities(arg):
    if not isinstance(arg, list):
        raise TypeError('Expected a list as an argument')
    my_list = []
    for capas in arg:
        try:
            capas_value = getattr(CapabilitySet, capas)
        except:
            raise ValueError('Invalid capability name: ' + str(capas))

        my_list.append(capas_value)

    result = getcapability(my_list)
    return result

#import pygtk
#import gtk
#import gobject
import logging

logger = logging.getLogger(__name__)

def ao_yield():
    pass

class Ao_lock:
    def wait(self):
        gtk.main()

    def signal(self):
        gtk.main_quit()

class Ao_timer:
    def __init__(self):
        logger.debug(self.__class__.__name__ + ' enter')
        self.timer_ = None
        self.callback_ = None
        logger.debug(self.__class__.__name__ + ' leave')

    def after(self, interval, callback = None):
        logger.debug(self.__class__.__name__ + ' enter')
        self.callback_ = callback
        logger.debug('interval=' + str(interval))
        self.timer_ = gobject.timeout_add(interval * 1000, self.after_cb_)
        logger.debug(self.__class__.__name__ + ' leave')

    def cancel(self):
        logger.debug(self.__class__.__name__ + ' enter')
        if self.timer_ != None:
            gobject.source_remove(self.timer_)
            self.timer_ = None

        logger.debug(self.__class__.__name__ + ' leave')

    def after_cb_(self):
        logger.debug(self.__class__.__name__ + ' enter')
        if self.callback_ != None:
            self.cancel()
            self.callback_()

        logger.debug(self.__class__.__name__ + ' leave')
